#!/bin/zsh

COLORS="#AA0000,#00AA00,#0000AA,#AA00AA,#000000,#00AAAA"
TYPES=""

gnuplot <<EOF
set terminal postscript enhanced color
set title "Benchmarks $2"
set ylabel "CPU seconds"
set xlabel "Precision in bits"
set log xy
set key left top


$(
C=1
for i in ${1}*.table; do
    echo "f$C(x) = a$C*x+b$C"
    echo "a$C = 1; b$C = 1"
    echo "fit f$C(x) '$i' using 1:2 via a$C,b$C;"
    echo "f$C(x) = a$C*x+b$C;"
    let C=$C+1;
done)

plot \
$(
#PISOT
#AB="(y=6.7e-06x+1);(y=3.8e-06x+1);(y=7.3e-06x+1);(y=3.46x+1)"
#SALEM
AB="(y=9.5e-06x+1);(y=7.3e-06x+1);(y=1.4e-05x+1)"
C=1
for i in $1*.table; do
    color="`echo $COLORS | cut -d, -f1`"
    COLORS="`echo $COLORS | cut -d, -f2-`"
    title="`echo $AB | cut -d';' -f1`"
    AB="`echo $AB | cut -d';' -f2-`"
    echo "     '$i' using 1:2 notitle lc rgb '$color'," '\';
    echo "     '$i' using 1:2 title '$i' with lines lc rgb '$color' lw 2," '\';
    echo "     f$C(x) title 'best fit of $i $title' with lines lc rgb '$color'," '\';
    let C=$C+1;
done)
           'file-that-does-not-exist' using 1:1 notitle with points
EOF


