from config import * 
import commands, os, uuid, gmpy


RETRIES = 10


def get_tmp_fn():
    return '/tmp/roots-%s.tmp' % uuid.uuid1()


def get(name):
    path = '%s%s' % (AWS_CACHE, name)
    if os.path.isfile(path):
        return file(path).read()
    data = None
    for i in xrange(RETRIES):
        commands.getoutput(BIN_PATH + '/s3get.sh "%s"' % name)
        try:
            os.rename(name, path)
            data = file(path).read()
            os.unlink(path)
            break
        except:
            raise Warning('Retrying download of "%s"..' % name)
    if data == None:
        raise Exception('Could not download "%s".' % name)
    return data

def try_get(name):
    for i in xrange(RETRIES):
        commands.getoutput(BIN_PATH + '/s3get.sh %s' % name)
        try:
            os.unlink(name)
            return True
        except:
            pass
    return False

def put(name, value):
    tmp = get_tmp_fn()
    open(tmp,'w').write(value)
    for i in xrange(RETRIES):
        commands.getoutput(BIN_PATH + '/s3put.sh %s %s' % (name, tmp) )
        if try_get(name):
            break
    os.unlink(tmp)


def get_mpf(name):
    data = get(name)
    return gmpy.mpf(data, len(data)*4, 16)

def put_mpf(name, value):
    put(name, value.digits(16))

