#include "ffc.h"

#include <gmp.h>


char* get_ks(unsigned int* counts, size_t length,
	     int base, int block_size, unsigned int outcomes)
{
  mpf_t Dnp;
  mpf_t pos;
  mpf_t expect, actual;
  
  long sum=0;

  mpf_init_set_ui(Dnp, 0);

  mpf_init(pos);

  mpf_init(expect);
  mpf_init(actual);

  mpf_t expect1;
  mpf_init_set_ui(expect1, 1);
  mpf_div_ui(expect1, expect1, outcomes);
  mpf_set_ui(expect, 0);

  int i;
  for(i = 0; i < outcomes; i++) {
    sum += counts[i];

    // sum/N
    mpf_set_ui(actual, sum);
    mpf_div_ui(actual, actual, length);

    // (i+1)/base
    //mpf_set_ui(expect, i+1);
    //mpf_div_ui(expect, expect, outcomes);
    mpf_add(expect, expect, expect1);

    // Compute Dn+
    mpf_sub(pos, expect, actual);
    mpf_abs(pos, pos);
    if(mpf_cmp(pos, Dnp) > 0) {
      mpf_set(Dnp, pos);
    }
  }

  // clean up
  mpf_clear(expect);
  mpf_clear(actual);

  // compute sqrt(N)*max(pos,neg)
  mpf_t res;
  mpf_init_set_ui(res, length);
  mpf_sqrt(res, res);
  mpf_mul(res, res, Dnp);

  // clean up
  mpf_clear(pos);
  mpf_clear(Dnp);

  // generate result string
  char* str_res;
  str_res = mpf_to_str(res);
  mpf_clear(res);
  return str_res;
}

