#include "ffc.h"
#include <gmp.h>

// GLOBAL VARIABLE
int FREQS_IS_OK = 0;

char* get_freqs(unsigned int* counts, size_t length,
		int base, int block_size, unsigned int outcomes,
		unsigned long lmin, unsigned long lmax)
{
	mpf_t min, max, expected, res;
	double dres;

	mpf_init_set_ui(expected, length);
	mpf_div_ui(expected, expected, outcomes);

	unsigned int i;

	/*unsigned long lmin = counts[0];
	for(i = 1; i < outcomes; i++) {
	  long v = counts[i];
	  lmin = v < lmin ? v : lmin;
	  }*/

	//printf("min: %ld\nmax: %ld\n", lmin, lmax);

	mpf_init_set_ui(min, lmin);
	mpf_init_set_ui(max, lmax);

	mpf_div(min, min, expected);
	mpf_div(max, max, expected);

	mpf_sub_ui(min, min, 1);
	mpf_sub_ui(max, max, 1);

	mpf_init(res);
	mpf_abs(res, min);
	if (mpf_cmp(max, res) > 0)
	  mpf_set(res, max);
	else mpf_set(res, min);

	mpf_add_ui(res, res, 1);

	// Generate string (preserves precision)
	char* str_res;
	str_res = mpf_to_str(res);

	// Check if OK: |res-1| <= 0.05
	mpf_sub_ui(res, res, 1);
	mpf_abs(res, res);
	mpf_mul_ui(res, res, 100); // |res-1|*100 <= 5
	FREQS_IS_OK = (mpf_cmp_ui(res, 5) <= 0);
	

	mpf_clear(res);
	mpf_clear(min);
	mpf_clear(max);
	mpf_clear(expected);

	return str_res;
}

