import sys
from gmpy import mpz

# extract parameters
base, runlength = map(int, sys.argv[1:3])
data = file(sys.argv[3]).read()

# intervals: [:med_n] and [med_p:]
outcomes = base ** runlength
med_n = (outcomes)/2 - 1
med_p = (outcomes)/2 + (outcomes%2)

# median exists?
if med_p - med_n > 1:
    median = outcomes / 2
else:
    median = None

# init counters
runs = 0
neg = 0
pos = 0

# init
prev_run = 0
this_run = 0

l = len(data)

# first digit
d = mpz(data[:runlength], base)

for i in xrange(runlength, len(data) - runlength):
    # print progress
    if i % (1024*256) == 0:
        print (i * 100) / l

    if d == median:
        # median
        pass
    else:
        # negative digit
        if d <= med_n:
            neg += 1
            this_run = -1
        # positive digit
        elif d >= med_p:
            pos += 1
            this_run = 1
        if this_run != prev_run:
            runs += 1
        prev_run = this_run

    # next digit
    d = mpz(data[i:i+runlength], base)

print runs, neg, pos
