import sys, os
from distutils.core import setup, Extension

# monkey-patch distutils if it can't cope with the "classifiers" and
# "download_url" keywords
if sys.version < '2.2.3':
    from distutils.dist import DistributionMetadata
    DistributionMetadata.classifiers = None
    DistributionMetadata.download_url = None

# determine include and library dirs
incdirs = libdirs = ()
if sys.version.find('MSC') == -1:
    # Unix-like build (including MacOSX)
    incdirs = ['./src']
    dirord = ['/opt/local', '/usr/local']
    for adir in dirord:
        lookin = '%s/include' % adir
        if os.path.isfile(lookin + '/gmp.h'):
            incdirs.append(lookin)
            break
    for adir in dirord:
        lookin = '%s/lib' % adir
        if os.path.isfile(lookin + '/libgmp.a'):
            libdirs = [lookin]
            break

# decomment next line (w/gcc, only!) to support gcov
os.environ['CFLAGS'] = '-march=native -O3 -m64'
# prepare the extension for building
freqs_ext = Extension('_freqs', sources=['src/_freqs.c'],
    include_dirs=incdirs,
    library_dirs=libdirs,
    libraries=['gmp'])

setup (name = "_freqs",
       version = "0.1",
       maintainer = "Johan Brinch",
       maintainer_email = "zerrez@gmail.com",
       url = "",
       description = "",

       ext_modules = [ freqs_ext ]
)
