import database as db

class Model:
    def __init__(self, _row=None, **kwargs):
        for column in self.COLUMNS:
            setattr(self, column, None)
        if _row:
            for key in self.COLUMNS:
                try:
                    _row[key] # check that key exists
                except IndexError,e:
                    raise IndexError(key)
            for key in _row.keys():
                setattr(self, key, _row[key])
        else:
            for key,value in kwargs.items():
                assert key in self.COLUMNS
                setattr(self, key, value)
    
    def create(self):
        print 'creating: %s %s' % (self, self.TABLE)
        columns = ('%s SERIAL PRIMARY KEY,' % self.COLUMNS[0]) + ','.join('%s %s' % (self.COLUMNS[i], self.TYPES[i]) 
                                                                          for i in xrange(1,len(self.COLUMNS)))
        try:
            db.db_update('CREATE TABLE %s (%s)' % (self.TABLE, columns))
        except Exception,e:
            print e, 'Table exists?'
        db.db_commit()
    
    def save(self):
        sql = ''
        if self.id:
            _set = ', '.join('%s=%%s' % col for col in self.COLUMNS[1:]) 
            sql  = 'UPDATE %s SET %s WHERE id=%s' % (self.TABLE, _set, self.id)
        else:
            _set = ', '.join('%s' for col in self.COLUMNS[1:])
            sql  = 'INSERT INTO %s (%s) VALUES (%s)' % (self.TABLE, ', '.join(self.COLUMNS[1:]), _set)
        db.db_update(sql, tuple(getattr(self, attr) for attr in self.COLUMNS[1:]))
        if not self.id:
            self.id = db.db_execute_one('SELECT lastval() as row_id')['row_id']
        assert self.id
        return self 

    def save_to_file(self, file):
        sql = '\t'.join(tuple(getattr(self, attr) == None and 'NULL' or str(getattr(self, attr))
                              for attr in self.COLUMNS[1:]))
        file.write(sql + '\n')
        return self
    
    def query(self, query, params=()):
        for row in db.db_execute(query, params):
            yield self.__class__(_row=row)
    
    def query_one(self, query, params=()):
        row = db.db_execute_one(query, params)
        return row and self.__class__(_row=row) or None 
    
    def all(self):
        return self.query('SELECT * FROM %s' % (self.TABLE,))

    def __hash__(self):
        return hash(self.id)
    
    def __cmp__(self, other):
        return cmp(self.id, other.id)

    def __repr__(self):
        return repr(('MODEL:'+self.TABLE, dict((col, getattr(self, col)) for col in filter(lambda c: hasattr(self, c), self.COLUMNS))))
