from stats.frequency import reversed_freqs, lower_runlength, absolute_freqs, absolute_freqs_fast, BLOCK_SIZE
import time, gmpy


# larger is slower
N = 2**24
B = 3

# test data is digits of pi repeated
print 'computing pi..'
data = gmpy.pi(N+2).digits(B)
pos0 = data.index('.')
pos1 = data.rindex('e')
data = data[pos0+1:pos1]

# print size of data and num of blocks
print len(data), len(data) / BLOCK_SIZE

# compute statistics
start = time.time()
ff = absolute_freqs_fast(data, B)
print (time.time()-start)

print ff[1][-1]

print 'reversed [fast]..'
start = time.time()
fb = absolute_freqs_fast(data[::-1], B)
print (time.time()-start)

print 'reversed efficient..'
for k in fb:
    assert fb[k] == reversed_freqs(data, ff[k])


#high = max(ff.keys())
#freqs = ff[high]
#for i in xrange(1,high):
#print 'runlength:', i
#lower =  lower_runlength(data, freqs, 4)
#for rl in xrange(1,high):
#    print lower_runlength(data, freqs, rl) == ff[rl]
#for run in ff[4][0]:
#    new = lower[0][run]
#    old = ff[4][0][run]
#    if old != new:
#        print run, old, new



