import re
from database import *
from roots import PolyLib

TEX_HEADER = r'''
\begin{center}
\begin{longtable}{|l|l|}
\caption{List of numbers (given by their minimal polynomial)} \\
\hline \multicolumn{1}{|c|}{\textbf{Name}} & \multicolumn{1}{c|}{\textbf{Polynomial}} \\ \hline 
\endfirsthead

\multicolumn{2}{c}%
{{\bfseries \tablename\ \thetable{} -- continued from previous page}} \\
\hline \multicolumn{1}{|c|}{\textbf{Name}} &
\multicolumn{1}{c|}{\textbf{Polynomial}} \\ \hline 
\endhead

\hline \multicolumn{2}{|r|}{{Continued on next page}} \\ \hline
\endfoot

\hline \hline
\endlastfoot
'''

TEX_FOOTER = r'''
\end{longtable}
\end{center}
'''


def texify(s):
    return re.sub(r'x\^(\d+)', r'x^{\1}', s).replace('*',r'')



print TEX_HEADER

for t in ('pisot', 'salem', 'sqrt', 'random'):
    for poly in Polynomial().query('SELECT * FROM Polynomial WHERE name LIKE %s ORDER BY id',
                                   ('%s%%' % t,)):
        name = poly.name.capitalize()
        name = name.replace('-', ' ')
        name = re.sub(r'Sqrt (\d+)', r'$\sqrt{\1}$', name)
        spoly = ''
        for i,term in enumerate(texify(PolyLib.simplify(poly.polynomial)).split(' ')):
            spoly += '%s ' % term
            #if (i+1) % 16 == 0:
            #    spoly += r'\\'

        print r'%s & \begin{minipage}{280pt}$%s$\end{minipage} \\' % (name, spoly)
        print r'\hline'


print TEX_FOOTER
