from roots import PolyLib
from database import *
from decimal import Decimal
from scipy.stats import chi2
import re, sys, math

if len(sys.argv) != 5:
    print 'usage:   %s poly  dist  base runlength\nexample: %s pisot freqs 2    5' % (sys.argv[0], sys.argv[0])
    sys.exit(0)

def sci_str(s):
    d = Decimal(s)
    exp = int(abs(d).log10())
    if int(d / Decimal(10)**exp) == 0:
        exp += cmp(exp, 0)
    return '%.3fe%d' % (d / Decimal(10)**exp, exp)


def texify(s):
    return re.sub(r'x\^(\d+)', r'x^{\1}', s).replace('*',r'')

POLY = sys.argv[1]

DIST = '%s_lps' % sys.argv[2]
DIST_ID = Distribution().query_one('SELECT * FROM Distribution WHERE name=%s', (DIST,)).id

BASE = int(sys.argv[3])
RUNLENGTH = int(sys.argv[4])

polys = Polynomial().query("SELECT * FROM Polynomial WHERE name LIKE %s", ('%s-%%' % POLY,))
#polys = Polynomial().query('SELECT * FROM Polynomial')

degrees = {}
for poly in polys:
    degree = PolyLib.from_string(poly.polynomial).degree
    degrees[degree] = degrees.get(degree, []) + [poly]

for degree in sorted(degrees):
    results = []
    for poly in degrees[degree]:
        result = DistributionResult().query_one(
            'SELECT * FROM DistributionResult WHERE distribution_id=%s AND polynomial_id=%s '+
            'AND base=%s AND runlength=%s', (DIST_ID, poly.id, BASE, RUNLENGTH)).result

        results.append(int(result))
    _s = sum(results)
    N  = len(results)
    avg = _s / float(N)
    dev = math.sqrt( sum( (avg-i)**2 for i in results ) / N )
    print '%6i%16s%16s' % (degree, int(avg), int(dev))



