import sys
from stats.frequency import digits_mpf
from aws import s3
from database import * 


FIXED = 0
BASES = map(int, sys.argv[1:])


print 'building list of expected digit counts..'
poly = Polynomial().query_one('SELECT * FROM polynomial WHERE name=%s', ('pisot-1',))


def getName(poly, base):
    return '%s-b%i' % (poly.name, base)

def fetch(poly, base):
    return s3.get(getName(poly, base))

def putit(poly, base, digits):
    s3.put(getName(poly, base), digits)


digits_exp = {}
for base in BASES:
    print '> base:', base
    digits_exp[base] = len(fetch(poly, base))
    print '> digits:', digits_exp[base]



polys = Polynomial().query('SELECT * FROM polynomial WHERE name LIKE %s ORDER BY name',
                           ('salem-%',))

for poly in polys: 
    print '> checking %s..' % poly.name
    
    root = None
    for base in BASES:
        print '| base:', base
        digits = 0
        try:
            digits = len(fetch(poly, base))
        except:
            pass

        print digits, '~=', digits_exp[base]
        if abs(digits - digits_exp[base]) > 16:
            if root == None:
                print '| fetching root..'
                root = s3.get_mpf(poly.name)

            print '| recomputing digits..'
            digit_str = digits_mpf(root, base)

            print '| uploading..'
            putit(poly, base, digit_str)
            
            FIXED += 1


print '! fixed %i roots' % FIXED
print 'done.'
