from stats.frequency import digits_mpf
from processing.worker import process_job_freqs_base
from aws import s3
from database import * 
import sys


FIXED = 0
BASES = map(int, sys.argv[1:])

print 'fixing bases:', BASES


print 'building list of expected block counts..'
poly = Polynomial().query_one('SELECT * FROM polynomial WHERE name=%s', ('pisot-1',))

def getBlockCount(poly, base):
    runlength = db_execute_one('SELECT COUNT(runlength) FROM frequencygroup '+
                               'WHERE polynomial_id=%s AND base=%s', 
                               (poly.id, base))

    if runlength == None or runlength[0] == None: 
        return (0, 0)

    runlength = int(runlength[0])

    group = FrequencyGroup().query_one('SELECT * FROM frequencygroup '+
                                       'WHERE polynomial_id=%s AND base=%s AND runlength=%s', 
                                       (poly.id, base, runlength))
    if group: 
        return (runlength, 
                int(db_execute_one('SELECT COUNT(frequency_group_id) FROM frequencyblock '+
                                   'WHERE frequency_group_id=%s', 
                                   (group.id,))[0]))
    return (0, 0)


def deleteBlocks(poly, base):
    groups = FrequencyGroup().query('SELECT * FROM frequencygroup '+
                                    'WHERE polynomial_id=%s AND base=%s', 
                                    (poly.id, base))
    for group in groups:
        db_update('DELETE FROM frequencyblock '+
                  'WHERE frequency_group_id=%s', 
                  (group.id,))
        db_update('DELETE FROM frequencygroup '+
                  'WHERE id=%s', 
                  (group.id,))


def getName(poly, base):
    return '%s-b%i' % (poly.name, base)

def fetch(poly, base):
    return s3.get(getName(poly, base))

def putit(poly, base, digits):
    s3.put(getName(poly, base), digits)


blocks_exp = {}
for base in BASES:
    print '> base:', base
    blocks_exp[base] = getBlockCount(poly, base)
    print '> digits:', blocks_exp[base]



polys = Polynomial().query('SELECT * FROM polynomial WHERE '+
                           'name LIKE %s ORDER BY id',
                           ('random-%',))
for poly in polys: 
    print '> checking %s..' % poly.name
    for base in BASES:
        rl, count         = getBlockCount(poly, base)
        rl_exp, count_exp = blocks_exp[base]
        print count, '~=', count_exp, 'and', rl, '~=', rl_exp
        if rl != rl_exp or abs(count-count_exp) > 16:
            print '! needs recalc'
            print '> deleting..'
            deleteBlocks(poly, base)
            print '> recomputing..'
            job = Job().query_one('SELECT * FROM Job WHERE type=%s AND polynomial_id=%s', 
                                  ('stats', poly.id))
            process_job_freqs_base(job, poly, base)
            FIXED += 1
            
    
print '! %i roots needs recacultation' % FIXED
print 'done.'
