#!/bin/sh

G=graphics/agg
python new_run_aggregate.py $1 $2 $3 $4 > $G/data.tmp

mkdir -p $G/$2/$1;

(
gnuplot <<EOF
set terminal postscript eps enhanced color
set output '$G/$2/$1/$3_$4.eps'
set xlabel "degree"
set ylabel "lps"

f1(x) = a1*x+b1;
a1 = 1; b1 = 1;

fit f1(x) "$G/data.tmp" using 1:2 via a1,b1
f1(x) = a1*x+b1;
plot f1(x) title "best fit", \
  "$G/data.tmp" title "" with yerrorbars, "$G/data.tmp" title "$1 $2, base $3, runlength $4" with lines
EOF
)

#echo $G/$2/$1/$3_$4.png

#ps2pdf $G/$1_$2_$3_$4.ps $G/$1_$2_$3_$4.pdf
