import sys

import matplotlib 
matplotlib.use('Agg')

from pylab import * 
from scipy import stats

from stats.frequency import BLOCK_SIZE 


# compute the probability of getting this chi square
def chi_value(v, N):
    return 1-stats.chi2.cdf(v, N-1)


def chi_square_of_freqs(freqs, length, outcomes):
    expect = length / float(outcomes)
    chi2   = 0.0
    for event in freqs:
        chi2 += float(freqs[event] - expect)**2 / expect
    return chi_value(chi2, outcomes)


def chi_square_draw(freqss, outcomes):
    xs,ys = [], []
    for i, freqs in enumerate(freqss):
        chi2 = chi_square_of_freqs(freqs, sum(freqs.values()), outcomes)
        xs.append(i*BLOCK_SIZE)
        ys.append(chi2)

    # create graph
    #figure()

    # add points to graph
    plot(xs, ys, '-+')

    # add 0.05
    plot([0, xs[-1]], [0.05, 0.05], '-')

    # save graph
    #savefig(output)
    #close()
