import time, gmpy
from roots import pw, gm_old, mp

poly = '1x^3-1x^1-1x^0'


def usage(f, *args, **kwargs):
    start = time.time()
    f(*args, **kwargs)
    return time.time() - start


methods = [pw.power_method, gm_old.gupta_mittal]#, gm_old.gupta_mittal]

'''
xs = []
ys = [[], []]

for i in xrange(14, 18+1):
    xs.append(i)
    for j, method in enumerate(methods):
        t = usage(method, poly, i)
        ys[j].append(t)
        print '%15s %2s %.4f' % (method.__name__, i, t)
    
from graphics.plotting import Plot
plot = Plot()
for j,method in enumerate(methods):
    plot.plot(xs, ys[j])
plot.save('data/runtime-old.png')
'''

''' DIVISION '''
xs = []
ys = [[], []]

gmpy.rand('seed', 42)

N = gmpy.rand('next', 2**(2**18)/2) + 2**(2**18)/2
D = gmpy.rand('next', N/2) + N/2


for i in xrange(18,25):
    xs.append(i)
    t = usage(lambda : gmpy.mpf(gmpy.mpq(N,D), 2**i))
    ys[0].append(t)
    print '%8s %2s %.4f' % ('GMPlib', i, t)
    t = usage(lambda : pw.picarte_div(N, D, i+2))
    ys[1].append(t)
    print '%8s %2s %.4f' % ('Picarte', i, t)
    print 'generating N and D..'
    N **= 2
    D **= 2

from graphics.plotting import Plot
plot = Plot()
for j in (0,1):
    plot.plot(xs, ys[j])
plot.save('data/runtime-div.png')
