import os


def time_func(func):
    ''' 
    create wrapper that times cpu time
    cpu_time, result = time_func(add)(2, 3)
    cpu_time, result = time_func(lookup)(d={2:'t'},k=2)
    '''
    def wrapper(*args, **kwargs):
        utime_start, _, cutime_start, _, _ = os.times()
        resval, (utime_stop, _, cutime_stop, _, _) = func(*args, **kwargs), os.times()
        return ((utime_stop+cutime_stop) - (utime_start+cutime_start), resval)
    return wrapper
    
